TRANSFORMATION NormTrans
 -- get rid of NIL appearing in translated query

 USES

  nonil1: K (x) ! y --> x,
  nonil2: K (b) ? y --> b,
  comp:   (f o g) ! x --> f ! (g ! x),
  un2j:   unnest (f, K (B)) ! A --> join (K (true), f) ! [A, B],
  collij: iterate (p, f) ! (join (q, g) ! [A, B]) --> join (q & (p OPLUS g), f o g) ! [A, B],
  colljj: join (p, f) ! [join (q, g) ! [A1, A2], B] --> 
			join ((q OPLUS #1) & (p OPLUS <g o #1, #2>), f o <g o #1, #2>) ! [join (K (true), id) ! [A1, A2], B],
  FactorK,
  OrdUnnests,
  LB,
  SimpLits,
  SimpFunc,
  SimpPred

 BEGIN

  -- Step 1:  First get rid of NIL's
     {{GIVEN f ! _O DO {FactorK (f); nonil1}} || {GIVEN p ? _O DO {SimpLits (p); nonil2}}};
  
  -- Step 2:  Next, normalize to ensure that result is of the form (f1 ! (f2 ! ... (fn ! x)...))
     GIVEN f ! _O DO LB (f);
	 REPEAT {comp};

  -- Step 3:  Next Reorder Unnests so that Joins on Constant Expressions are Evaluated 1st
     OrdUnnests;

  -- Step 4:  Convert unnests over constant collections to joins
     BU {un2j};

  -- Step 5:  Collapse composed iterates and joins
	 BU {{collij || colljj} ->
           GIVEN join (p, f) ! _O DO {SimpPred (p); SimpFunc (f)}
		}
 END
