//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Joon Suk Lee (jl) 
//  FILE: CondList.H
//  PROJ: COKO
//  DATE: 10/97                                                             
//
// SYNOPSIS
//  Classes for Condition List.
//  
//////////////////////////////////////////////////////////////////////////////


#ifndef _CONDLIST_H_
#define _CONDLIST_H_

#include <strings.h>
#include <stdlib.h>
#include <iostream.h>
#include "PCCond.H"

class CondNode
{
public:
  CCond * _value;
  CondNode * _next;

  CondNode(CCond * c);
  // Constructor

  ~CondNode();
  // Destructor

};

class CondList
{
private:
  CondNode * _iterator;
  CondNode * _head;
  CondNode * _tail;

public:

  CondList();
  // Constructor
  
  ~CondList();
  // Destructor

  void insert(CCond* a);
  //  Insert a new node with _value = a to the list

  int pop();
  // Pop off a front node from the list
  // Return success value of the pop.

  CCond* top();
  // Returns _value of the top node.

  int empty();
  // Is the list empty?

  void initIterator();
  // Initialize _iterator
  // This method is used with getValue method

  CCond* getValue();
  // Returns _value of the node that _iterator is pointing to.
  // After a call to this method, _iterator will point to the next node.
  // One can call this methods repeatly to get the _value of all the nodes.
  // However, initIterator has to be called before the initial call to this 
  // method.  

};

#endif

