//////////////////////////////////////////////////////////////////////////////
//
//  NAME: Joon S.  Lee (jl)
//  FILE: PCEqn.H
//  PROJ: COKO
//  DATE: 10/9/96
//
// SYNOPSIS
//  Class definitions for Eqns.
//
//////////////////////////////////////////////////////////////////////////////
 
#ifndef _PCEQN_H_
#define _PCEQN_H_

#include "PCPattern.H"

class CEqn {
protected:
  char * _lhs;
  // stores left hand side of an equation ( variable name )

  CPattern * _rhs;
  // stores right hand side of an equation ( pattern )

  int _evalFlag;
  // indicates whether an equation has been evaluated or not
  // if an equation is not evaluated then _evalFlag is 0.
  // Otherwise, _evalFlag is 1.
  // We need _evalFlag to undo any changes that caused by evaluating equations.
  // We need to know which equation is evaluated and which is not.

  void SetEF(void);       
  // Set _evalFlag ( _evalFlag = 1 )

  void UnsetEF(void);     
  // Unset _evalFlag ( _evalFlag = 0 )

public:

  CEqn(char*, CPattern*); 
  // Constructor

  ~CEqn(); 
  // Destructor

  CState* Exec(CState *);  
  // What to do when executed

  CState* undoDEP(CState *);  
  // undo any changes on dependency list

  void endOfEval(void) {UnsetEF();}
  // evaluation of equation ended. unset _evalFlag as it was.

};

#endif
