//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Kee-Eung Kim (kek)                                             
//  FILE: PCMulStmtCon.H
//  PROJ: COKO
//  DATE: 8/27/96                                                              
//
// SYNOPSIS
//  Class definition for CMulStmtCon class.
//  
//////////////////////////////////////////////////////////////////////////////

#ifndef _PCMULSTMTCON_H_
#define _PCMULSTMTCON_H_

#include <PCStmt.H>

//////////////////////////////////////////////////////////////////////////////
//
//  CLASS: CMulStmtCon
//
// SYNOPSIS
//  This class is a derived class from CStmt. It is used for multiple 
//  statements connected by conjunction in COKO rule block.
//
//////////////////////////////////////////////////////////////////////////////

class CMulStmtCon : public CStmt
{
protected:
  CStmt *_first;                  // Former statement(s).
  CStmt *_second;                 // Later Statement.
public:
  CMulStmtCon(CStmt *, CStmt *);  // Constructor
  ~CMulStmtCon(void);             // Destructor
  CState *Exec(CState *);         // What to do when executed.

};

#endif
