//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Kee-Eung Kim (kek)                                             
//  FILE: PCMatchStmt.H
//  PROJ: COKO
//  DATE: 8/27/96                                                              
//
// SYNOPSIS
// Class definitions for CMatchStmt.
//  
//////////////////////////////////////////////////////////////////////////////

#ifndef _PCMATCHSTMT_H_
#define _PCMATCHSTMT_H_

#include "PCStmt.H"
#include "PCPattern.H"

#ifdef COKO_DEBUGGER
#include "CFGMatchStmt.H"
#endif

class CFGObject;
class CFGPopEnv;

//////////////////////////////////////////////////////////////////////////////
//
//  CLASS: CMatchStmt
//
// SYNOPSIS
//  This class is a derived class from CStmt. It is used for Match
//  statements in COKO rule block.
//
//////////////////////////////////////////////////////////////////////////////

class CMatchStmt : public CStmt {
protected:
  CPattern *_first;                   // Pattern specified with the statement
  CStmt *_second;                     // Match statement body
public:

#ifndef COKO_DEBUGGER
  CMatchStmt(CPattern *, CStmt *);    // Constructor
#endif

  ~CMatchStmt();                      // Destructor
  CState *Exec(CState *);             // What to do when executed



#ifdef COKO_DEBUGGER    // added by gwk

protected:
    CFGObject * _cfgnode;
    CFGPopEnv * _pop;
    
public:
    friend CMatchEachStmt;

  CMatchStmt(CPattern *, CStmt *, CID_RBTextInfo* t);    // Constructor    

    CPattern*   getPattern()    {return _first;};
    CStmt*      getStmt()       {return _second;};
    CFGObject * getCfgNode()       {return _cfgnode;};      
    void        setCfgNode(CFGObject* n) 
    { if (_cfgnode != NULL) delete _cfgnode;
    _cfgnode = n;};
    
    CFGPopEnv * getPopEnv()     {return _pop;};

    virtual CFGObject*  GenCFG();
    virtual void        setSuccess(CFGObject* );
    virtual void        setFailure(CFGObject* );

#endif // COKO_DEBUGGER
};

#endif
