//////////////////////////////////////////////////////////////////
//
//  NAME: Joon S. Lee (jl)
//  
//  FILE: PCRule.H
//  PROJ: COKO
//  DATE: 6/96
// 
//  SYNOPSIS
//  This class is for Rule Declaration/Invoke statements.
//
/////////////////////////////////////////////////////////////////

#ifndef _PCRULE_H_
#define _PCRULE_H_

#include <PCState.H>
#include "KONameUnion.H"
#include "KGlobals.H"
#include "PCPattern.H"
#include "KONonType.H"

class CRule
{
 public:
  CRule (CPattern*, CPattern*);
  //  Constructor for rule representation. 
  //  Takes two arguments that are patterns of
  //  lhs and rhs, respectively. 

  virtual ~CRule();
  // Destructor
 
  virtual CState *Exec(CState*);
  //  Executes the given statement.
  //  Takes the state of the program before the statement
  //  is executed, and then returns the state of the 
  //  program after the statement is executed.

  CState *InvExec(CState*);
  //  Executes the given statement "in reverse".
  //  Takes the state of the program before the statement
  //  is executed, and then returns the state of the 
  //  program after the statement is executed.

 protected:

  CPattern* _lhs;
  CPattern* _rhs;
};

#endif
