//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Kee-Eung Kim (kek)                                             
//  FILE: PCRuleBlock.H
//  PROJ: COKO
//  DATE: 8/27/96                                                              
//
// SYNOPSIS
//  Class definition for CRuleBlock class.
//  
//////////////////////////////////////////////////////////////////////////////

#ifndef _PCRULEBLOCK_H_
#define _PCRULEBLOCK_H_

#include <PCStmt.H>
#include <PCState.H>

//////////////////////////////////////////////////////////////////////////////
//
//  CLASS: CRuleBlock
//
// SYNOPSIS
//  This class is an abstract base class for rule blocks. When the COKO parser
//  generates C++ code for a rule block, it will make the rule block a
//  derived class of CRuleBlock.
//
//////////////////////////////////////////////////////////////////////////////

class CRuleBlock 
{
public:
  virtual CState *Exec(CState *s) { return s; }  // It does nothing by default
};

#endif

