/* -*-Mode:c++-*- */

//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Mitch Cherniack (mfc)					 	    
//  FILE: QLAuxCode.H 
//  PROJ: QiteL->KOLA Translator
//  DATE: 6/98
//  
//////////////////////////////////////////////////////////////////////////////

#ifndef QLAUXCODE_HEADER
#define QLAUXCODE_HEADER 

#include "KGlobals.H"
#include "KOBAnd.H"
#include "KOBEqu.H"
#include "KOBGE.H"
#include "KOBGT.H"
#include "KOBInvoke.H"
#include "KOBLE.H"
#include "KOBLT.H"
#include "KOBName.H"
#include "KOBNot.H"
#include "KOBOr.H"
#include "KOBPrimitive.H"
#include "KOBVar.H"
#include "KOBool.H"
#include "KOFTID.H"
#include "KOF1.H"
#include "KOF2.H"
#include "KOFAbs.H"
#include "KOFAdd.H"
#include "KOFAvg.H"
#include "KOFCElt.H"
#include "KOFChoose.H"
#include "KOFCompose.H"
#include "KOFCon.H"
#include "KOFConst.H"
#include "KOFCount.H"
#include "KOFDif.H"
#include "KOFDiv.H"
#include "KOFFlatten.H"
#include "KOFFold.H"
#include "KOFID.H"
#include "KOFIns.H"
#include "KOFInt.H"
#include "KOFInverse.H"
#include "KOFIter.H"
#include "KOFIterate.H"
#include "KOFJoin.H"
#include "KOFLSJoin.H"
#include "KOFMax.H"
#include "KOFMin.H"
#include "KOFMinus.H"
#include "KOFMod.H"
#include "KOFMult.H"
#include "KOFNJoin.H"
#include "KOFPCon.H"
#include "KOFPFold.H"
#include "KOFPlus.H"
#include "KOFRSJoin.H"
#include "KOFSet.H"
#include "KOFSingleton.H"
#include "KOFSort.H"
#include "KOFSum.H"
#include "KOFTimes.H"
#include "KOFUni.H"
#include "KOFUnnest.H"
#include "KOFUser.H"
#include "KOFVar.H"
#include "KOFunction.H"
#include "KONameUnion.H"
#include "KONonType.H"
#include "KOOAny.H"
#include "KOODif.H"
#include "KOODiv.H"
#include "KOOFloat.H"
#include "KOOId.H"
#include "KOOIf.H"
#include "KOOInt.H"
#include "KOOInter.H"
#include "KOOInvoke.H"
#include "KOOLink.H"
#include "KOOMinus.H"
#include "KOOMult.H"
#include "KOOName.H"
#include "KOOPair.H"
#include "KOOPlus.H"
#include "KOOSet.H"
#include "KOOStr.H"
#include "KOOTimes.H"
#include "KOOUni.H"
#include "KOOVar.H"
#include "KOObjList.H"
#include "KOObject.H"
#include "KOPCEX.H"
#include "KOPCElt.H"
#include "KOPCFA.H"
#include "KOPCombine.H"
#include "KOPConjunct.H"
#include "KOPConst.H"
#include "KOPDisjunct.H"
#include "KOPEqual.H"
#include "KOPExists.H"
#include "KOPForall.H"
#include "KOPGreater.H"
#include "KOPGreaterEqual.H"
#include "KOPInv.H"
#include "KOPIsnotnull.H"
#include "KOPIsnull.H"
#include "KOPLess.H"
#include "KOPLessEqual.H"
#include "KOPLex.H"
#include "KOPNegate.H"
#include "KOPNotEqual.H"
#include "KOPTimes.H"
#include "KOPUser.H"
#include "KOPVar.H"
#include "KOPredicate.H"
#include "KOTWrap.H"

#include "TYTAny.H"
#include "TYTBag.H"
#include "TYTBool.H"
#include "TYTChar.H"
#include "TYTDC.H"
#include "TYTError.H"
#include "TYTFlt.H"
#include "TYTFunc.H"
#include "TYTInt.H"
#include "TYTObj.H"
#include "TYTPair.H"
#include "TYTPred.H"
#include "TYTSet.H"
#include "TYTStr.H"
#include "TYTTup.H"
#include "TYTUnk.H"
#include "TYTUser.H"
#include "TYTVar.H"
#include "TYType.H"

#include "ENEnvironment.H"
#include "ENEnvEntry.H"

#include <iostream.h>
#include <strings.h>
#include <string.h>

Environment *initenv ();
Predicate *CopyPred (Predicate *p);
Function *CopyFunc (Function *f);
Function *PairFunc (Function *f1, Function *f2);
Function *OptimizedCompose (Function *f1, Function *f2);
Predicate *OptimizedCombine (Predicate *p, Function *f);

//////////////////////////// Rule Routines ///////////////////////////////////////
Function *IntFunc (int i);
Function *StrFunc (char *s);
Function *FloatFunc (char *s);
Function *NilFunc ();

Function *ElementFunc (Function *f1);
Function *AbsFunc (Function *f1);
Function *PlusFunc (Function *f1, Function *f2);
Function *MinusFunc (Function *f1, Function *f2);
Function *MultFunc (Function *f1, Function *f2);
Function *DivFunc (Function *f1, Function *f2);
Function *ModFunc (Function *f1, Function *f2);
Function *NegFunc (Function *f);
Predicate *EqPred (Function *f1, Function *f2);
Predicate *NeqPred (Function *f1, Function *f2);
Predicate *LTPred (Function *f1, Function *f2);
Predicate *GTPred (Function *f1, Function *f2);
Predicate *LEQPred (Function *f1, Function *f2);
Predicate *GEQPred (Function *f1, Function *f2);
Predicate *IsNullPred (Function *f);
Predicate *IsNotNullPred (Function *f);
Predicate *NotPred (Predicate *p);
Predicate *AndPred (Predicate *p1, Predicate *p2);
Predicate *OrPred (Predicate *p1, Predicate *p2);
Function *FlattenFunc (Function *f);
Function *UniFunc (Function *f1, Function *f2);
Function *InterFunc (Function *f1, Function *f2);
Function *DifFunc (Function *f1, Function *f2);
Predicate *InPred (Function *f1, Function *f2);
Function *COUNTFunc (Function *f);
Function *SUMFunc (Function *f);
Function *MINFunc (Function *f);
Function *MAXFunc (Function *f);
Function *AVGFunc (Function *f);
Environment *QuanEnv (Environment *e, char *s);
Predicate *FORALLPred (Function *f, Predicate *p);
Predicate *EXISTSPred (Function *f, Predicate *p);
Function *SFWFunc (Function *of, Function *f1, Function *f2, Predicate *p, int d);
Environment *QEnvEnv (Environment *env, char *s);
Function *QEnvFunc (Function *f);
Function *QEnvFunc2 (Function *f1, Function *f2);
Function *IdentFunc (char *s, Environment *e);
Predicate *IdentPred (char *s, Environment *e);
Function *Path1Func (char *s, Function *f, Function *af);
Predicate *Path1Pred (char *s, Function *f, Function *af);
Function *Path2Func (char *s, Function *f);
Predicate *Path2Pred (char *s, Function *f);
Function *Sort1Func (Function *f, Predicate *p);
Function *Sort2Func (char *s, Predicate *p);
#endif





